/* [Overview] */
//Part
PARTNO = "0"; // [0:All, 1:Base ,2:Cover]
// default part number

/* [Parameters] */
$fn = 100;
/* [Parameters] */
$fa = 12;
/* [Parameters] */
$fs = 2;

/* [Sizes] */
width = 5;
/* [Sizes] */
length = 63;
/* [Sizes] */
height = 32;
/* [Sizes] */
socketdepth = 12;
/* [Sizes] */
thickness = 2;
/* [Parameters] */
hinge = 1.5;
/* [Parameters] */
stop = 3;
/* [Parameters] */
size = 6.35;
/* [Parameters] */
fudgefactor = 0.075;

/* [Sizes] */
slots = 6;

use <hexagon.scad>;

//BASE
module base() {
difference (){
union()
{
translate([thickness*1.1,0,0])
cube([length-thickness*2.2,width,socketdepth+thickness]);

translate([thickness,0,stop*3])
//rotate([0,90,0])
sphere(d=stop);  

translate([length-thickness*1.2,0,stop*3])
//rotate([0,90,0])
sphere(d=stop); 
    


};
union()
{
translate([-thickness*0.05,-stop*1.2,stop*2.5])
cube([thickness*3,stop*1.2,stop*1.2]); 

translate([length-thickness*3,-stop*1.2,stop*2.5])
cube([thickness*3,stop*1.2,stop*1.2]); 

    
for (i=[1:slots]) {
    
translate([-size/4,width/2,thickness])
        {linear_extrude(20)
rotate([0,0,90])
hexagon(size/2+fudgefactor,0,-(length-size)*(i/slots));};

translate([length-thickness*2.1,width/2,width/2])
rotate([0,90,0])
cylinder(thickness*1.5, d1=hinge,  d2=hinge); 

translate([thickness*0.6,width/2,width/2])
rotate([0,90,0])
cylinder(thickness*1.5, d1=hinge,  d2=hinge);  

        };
};
};
};


//COVER
module cover() {
     difference (){
union()
{
translate([thickness*1.5,0,height-thickness])
cube([length-thickness*3,width,thickness]);

translate([0,0,width/2])
cube([thickness,width,height-width/2-thickness*1.5]);

translate([length-thickness,0,width/2])
cube([thickness,width,height-width/2-thickness*1.5]);

translate([length-thickness*1.5,width,height-(thickness*1.5)])
rotate([90,0,0])
    cylinder(width, d1=thickness*3, d2=thickness*3);  

translate([thickness*1.5,width,height-(1.5*thickness)])
rotate([90,0,0])
    cylinder(width, d1=thickness*3, d2=thickness*3);  

translate([length-thickness,width/2,width/2])
rotate([0,90,0])
#cylinder(thickness, d1=width, d2=width);  

translate([0,width/2,width/2])
rotate([0,90,0])
cylinder(thickness, d1=width, d2=width);  

translate([0,0,0])
cube([thickness,width/2,width]);

translate([length-thickness,0,0])
cube([thickness,width/2,width]);

};

union()
{

translate([-thickness*0.05,width/2,width/2])
rotate([0,90,0])
cylinder(thickness*1.1, d1=hinge*1.1,  d2=hinge*1.1);  

translate([length-thickness*1.05,width/2,width/2])
rotate([0,90,0])
#cylinder(thickness*1.1, d1=hinge*1.1,  d2=hinge*1.1); 

translate([thickness*1.05,0,stop*3])
sphere(d=stop*1.1);  

translate([length-thickness*1.05,0,stop*3])
sphere(d=stop*1.1);  

translate([length-thickness*2,width,height-thickness*2])
rotate([90,0,0])
    cylinder(width, d1=thickness*2, d2=thickness*2);  

translate([thickness*2,width,height-thickness*2])
rotate([90,0,0])
    cylinder(width, d1=thickness*2, d2=thickness*2);  

translate([thickness,0,height-thickness*4.5])
cube([width,width,width]);

translate([thickness*2,0,height-(thickness*3.5)])
#cube([width,width,width]);

translate([length-thickness*3.5,0,height-thickness*4.5])
cube([width,width,width]);

translate([length-thickness*4.5,0,height-(thickness*3.5)])
cube([width,width,width]);

translate([0,width/2,width/2])
rotate([0,90,0])
cylinder(h=1.521,r1=1.76,r2=0);

translate([length,width/2,width/2])
rotate([0,-90,0])
cylinder(h=1.521,r1=1.76,r2=0);
};

};    
};

 if (PARTNO == "1") base();
 if (PARTNO == "2") cover();
     
  // optionally use 0 for whole object
 if (PARTNO == "0") {
   base();
   cover();
 }